/*
  SD Datalogger with XBee.side

  Application prompts you to type numbers into SimpleIDE Terminal, and
  records to SD.  Plays back all numbers after you type q and press Enter.

  Has test code for sending XBee into command mode and verifying that it got
  there.
  
  SD tutorial:
  http://learn.parallax.com/propeller-c-simple-devices/sd-card-data
*/

#include "simpletools.h"                      // Include simpletools header    .
#include "xb.h"

int DO = 22, CLK = 23, DI = 24, CS = 25;      // SD card pins on Propeller BOE

int main(void)                                // Main function
{

  xb_start(9, 8, 0, 9600);                    // XB_DO -> P9, XB_DI -> P8

  xb_str("+++");
  char s[20];
  //fdserSpin_Strin(s);
  for(int n = 0; n < 3; n++) 
  {
    s[n] = xb_rx();
  }

  pause(1000);
  for(int i = 0; i < 3; i++) printf("%c", s[i]);

  pause(2000);                                // Delay for terminal
  printf("Enter several values.\n");          // User instructions
  printf("To exit, type q then Enter\n");

  sd_mount(DO, CLK, DI, CS);                  // Mount SD card

  FILE* fp = fopen("test.txt", "wb");         // Open a file for writing

  int n, status;                              // Number & status variables
  while(1)                                    // Endless loop
  {
    printf("> ");                             // User prompt
    status = scanf("%d", &n);                 // Get number & status
    if(!status) break;                        // Status 0? Break out of loop
    fwrite(&n, 4, 1, fp);                     // Write number to SD card
  } 
  fclose(fp);                                 // Close the file
  
  printf("\nYou entered:\n");                 // List heading

  fp = fopen("test.txt", "rb");               // Open a file for writing
  while(1)
  {
    status = fread(&n, 4, 1, fp);             // Read from SD & get status
    if(!status) break;                        // If no more, break loop
    printf("n = %d\n", n);                    // Display value
  } 
  fclose(fp);                                 // Close the file
}    

